Index: /experimental/TerrainTest/ModificationManager/Export.h
===================================================================
--- /experimental/TerrainTest/ModificationManager/Export.h	(revision 278)
+++ /experimental/TerrainTest/ModificationManager/Export.h	(revision 279)
@@ -0,0 +1,49 @@
+/* -*-c++-*- OpenSceneGraph - Copyright (C) 1998-2006 Robert Osfield 
+ *
+ * This library is open source and may be redistributed and/or modified under  
+ * the terms of the OpenSceneGraph Public License (OSGPL) version 0.0 or 
+ * (at your option) any later version.  The full license is in LICENSE file
+ * included with this distribution, and on the openscenegraph.org website.
+ * 
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
+ * OpenSceneGraph Public License for more details.
+*/
+
+#ifndef TERRAINMODMANAGER_EXPORT_
+#define TERRAINMODMANAGER_EXPORT_ 1
+
+#include<osg/Config>
+
+#if defined(_MSC_VER) && defined(OSG_DISABLE_MSVC_WARNINGS)
+    #pragma warning( disable : 4244 )
+    #pragma warning( disable : 4251 )
+    #pragma warning( disable : 4267 )
+    #pragma warning( disable : 4275 )
+    #pragma warning( disable : 4290 )
+    #pragma warning( disable : 4786 )
+    #pragma warning( disable : 4305 )
+    #pragma warning( disable : 4996 )
+#endif
+
+#if defined(_MSC_VER) || defined(__CYGWIN__) || defined(__MINGW32__) || defined( __BCPLUSPLUS__)
+    #  if defined( OSG_LIBRARY_STATIC )
+    #    define TERRAINMODMANAGER_EXPORT
+    #  elif defined( TERRAINMODMANAGER_LIBRARY )
+    #    define TERRAINMODMANAGER_EXPORT   __declspec(dllexport)
+    #  else
+    #    define TERRAINMODMANAGER_EXPORT   __declspec(dllimport)
+    #  endif
+#else
+    #  define TERRAINMODMANAGER_EXPORT
+#endif  
+
+/**
+
+\namespace osgTerrain
+
+The osgTerrain library is a NodeKit that provides geospecifc terrain rendering support. 
+*/
+
+#endif
Index: /experimental/TerrainTest/ModificationManager/ModificationManager.cpp
===================================================================
--- /experimental/TerrainTest/ModificationManager/ModificationManager.cpp	(revision 278)
+++ /experimental/TerrainTest/ModificationManager/ModificationManager.cpp	(revision 279)
@@ -23,5 +23,4 @@
 //-
 
-#define USE_TERRAIN_PROTO_WORKAROUND USE_TERRAIN_PROTO_WORKAROUND
 
 
Index: /experimental/TerrainTest/ModificationManager/ModificationManager.h
===================================================================
--- /experimental/TerrainTest/ModificationManager/ModificationManager.h	(revision 278)
+++ /experimental/TerrainTest/ModificationManager/ModificationManager.h	(revision 279)
@@ -16,5 +16,5 @@
 */
 
-#include "region.h"
+#include <region.h>
 #include "myTileLoadedCallback.h"
 #include "terrainModificationTechnique.h"
@@ -23,4 +23,6 @@
 #include <osg/observer_ptr>
 #include <vector>
+
+#include "Export.h"
 
 
@@ -42,5 +44,5 @@
  * @date  Mrz 2011
  */ 
-class ModificationManager
+class TERRAINMODMANAGER_EXPORT ModificationManager
 {
 public:
@@ -103,5 +105,5 @@
 
 	//! Copy-Constructor: Private to avoid that someone can create an class instance by copying the singleton instance.
-	ModificationManager(const ModificationManager& cc) {};
+	ModificationManager(const ModificationManager& cc) {cc;};
 
 	//! Vector of all managed terrain pointers.
Index: /experimental/TerrainTest/ModificationManager/ModificationManager.vcproj
===================================================================
--- /experimental/TerrainTest/ModificationManager/ModificationManager.vcproj	(revision 278)
+++ /experimental/TerrainTest/ModificationManager/ModificationManager.vcproj	(revision 279)
@@ -42,5 +42,6 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;MODIFICATIONMANAGER_EXPORTS"
+				AdditionalIncludeDirectories="&quot;$(OSG_ROOT)\include&quot;;..\;.\"
+				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;MODIFICATIONMANAGER_EXPORTS;TERRAINMODMANAGER_LIBRARY;USE_TERRAIN_PROTO_WORKAROUND"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -61,7 +62,12 @@
 			<Tool
 				Name="VCLinkerTool"
+				LinkLibraryDependencies="false"
+				AdditionalDependencies="osgTerraind.lib osgDBd.lib osgd.lib OpenThreadsd.lib"
+				OutputFile="$(OutDir)\$(ProjectName)d.dll"
 				LinkIncremental="2"
+				AdditionalLibraryDirectories="$(OSG_ROOT)/lib"
 				GenerateDebugInformation="true"
 				SubSystem="2"
+				ImportLibrary="$(TargetDir)$(TargetName).lib"
 				TargetMachine="1"
 			/>
@@ -115,5 +121,6 @@
 				Optimization="2"
 				EnableIntrinsicFunctions="true"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;MODIFICATIONMANAGER_EXPORTS"
+				AdditionalIncludeDirectories="&quot;$(OSG_ROOT)\include&quot;;..\;.\"
+				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;MODIFICATIONMANAGER_EXPORTS;TERRAINMODMANAGER_LIBRARY;USE_TERRAIN_PROTO_WORKAROUND"
 				RuntimeLibrary="2"
 				EnableFunctionLevelLinking="true"
@@ -133,5 +140,8 @@
 			<Tool
 				Name="VCLinkerTool"
+				LinkLibraryDependencies="false"
+				AdditionalDependencies="osgTerrain.lib osgDB.lib osg.lib OpenThreads.lib"
 				LinkIncremental="1"
+				AdditionalLibraryDirectories="$(OSG_ROOT)/lib"
 				GenerateDebugInformation="true"
 				SubSystem="2"
@@ -171,4 +181,12 @@
 			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
 			>
+			<File
+				RelativePath=".\ModificationManager.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\myTerrainTechnique.cpp"
+				>
+			</File>
 		</Filter>
 		<Filter
@@ -177,4 +195,20 @@
 			UniqueIdentifier="{93995380-89BD-4b04-88EB-625FBE52EBFB}"
 			>
+			<File
+				RelativePath=".\Export.h"
+				>
+			</File>
+			<File
+				RelativePath=".\ModificationManager.h"
+				>
+			</File>
+			<File
+				RelativePath="..\myTerrainTechnique.h"
+				>
+			</File>
+			<File
+				RelativePath="..\region.h"
+				>
+			</File>
 		</Filter>
 		<Filter
Index: /experimental/TerrainTest/ModificationVisitor.cpp
===================================================================
--- /experimental/TerrainTest/ModificationVisitor.cpp	(revision 278)
+++ /experimental/TerrainTest/ModificationVisitor.cpp	(revision 279)
@@ -26,4 +26,6 @@
 	// Set ROI to flatten and estimated height after correction
 	_technique->setModifiedHeight(600);	// 450
+
+	ModificationManager::getInstance()->addTerrainToManage( new osgTerrain::Terrain() );
 }
 
Index: /experimental/TerrainTest/ModificationVisitor.h
===================================================================
--- /experimental/TerrainTest/ModificationVisitor.h	(revision 278)
+++ /experimental/TerrainTest/ModificationVisitor.h	(revision 279)
@@ -24,4 +24,5 @@
 #include "ellipsoidTechnique.h"
 #include "rampedEllipsoidTechnique.h"
+#include "ModificationManager/ModificationManager.h"
 
 
Index: /experimental/TerrainTest/Plugins terrainmod/Plugins terrainmod.vcproj
===================================================================
--- /experimental/TerrainTest/Plugins terrainmod/Plugins terrainmod.vcproj	(revision 278)
+++ /experimental/TerrainTest/Plugins terrainmod/Plugins terrainmod.vcproj	(revision 279)
@@ -41,5 +41,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="$(OSG_ROOT)/include"
+				AdditionalIncludeDirectories="&quot;$(OSG_ROOT)/include&quot;;.\;..\"
 				PreprocessorDefinitions="WIN32;_WINDOWS;_DEBUG;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_DEPRECATE;osgdb_terrainmod_EXPORTS"
 				MinimalRebuild="true"
@@ -62,9 +62,9 @@
 				Name="VCLinkerTool"
 				LinkLibraryDependencies="false"
-				AdditionalDependencies="osgTerraind.lib osgDBd.lib osgd.lib OpenThreadsd.lib"
+				AdditionalDependencies="osgTerraind.lib osgDBd.lib osgd.lib OpenThreadsd.lib ModificationManagerd.lib"
 				OutputFile="$(OSG_ROOT)\bin\osgPlugins-2.9.12\osgdb_terrainmodd.dll"
 				Version="0.0"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="$(OSG_ROOT)/lib"
+				AdditionalLibraryDirectories="&quot;$(OSG_ROOT)/lib&quot;;.\Debug"
 				GenerateDebugInformation="true"
 				TargetMachine="1"
@@ -119,5 +119,5 @@
 				Optimization="2"
 				EnableIntrinsicFunctions="true"
-				AdditionalIncludeDirectories="$(OSG_ROOT)/include"
+				AdditionalIncludeDirectories="&quot;$(OSG_ROOT)/include&quot;;.\;..\"
 				PreprocessorDefinitions="WIN32;_WINDOWS;NDEBUG;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_DEPRECATE;osgdb_terrainmods_EXPORTS"
 				RuntimeLibrary="2"
@@ -138,9 +138,9 @@
 				Name="VCLinkerTool"
 				LinkLibraryDependencies="false"
-				AdditionalDependencies="osgTerrain.lib osgDB.lib osg.lib OpenThreads.lib"
+				AdditionalDependencies="osgTerrain.lib osgDB.lib osg.lib OpenThreads.lib ModificationManager.lib"
 				OutputFile="$(OSG_ROOT)\bin\osgPlugins-2.9.12\osgdb_terrainmod.dll"
 				Version="0.0"
 				LinkIncremental="1"
-				AdditionalLibraryDirectories="$(OSG_ROOT)/lib"
+				AdditionalLibraryDirectories="&quot;$(OSG_ROOT)/lib&quot;;.\Release"
 				GenerateDebugInformation="false"
 				OptimizeReferences="2"
@@ -175,42 +175,4 @@
 	<Files>
 		<Filter
-			Name="Quelldateien"
-			Filter="cpp;c;cc;cxx;def;odl;idl;hpj;bat;asm;asmx"
-			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
-			>
-			<File
-				RelativePath="..\ellipsoidTechnique.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\ModificationManager.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\ModificationVisitor.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\myTerrainTechnique.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\rampedEllipsoidTechnique.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\ReaderWriterTerrainMod.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\region.cpp"
-				>
-			</File>
-			<File
-				RelativePath="..\terrainModificationTechnique.cpp"
-				>
-			</File>
-		</Filter>
-		<Filter
 			Name="Headerdateien"
 			Filter="h;hpp;hxx;hm;inl;inc;xsd"
@@ -222,5 +184,5 @@
 			</File>
 			<File
-				RelativePath="..\ModificationManager.h"
+				RelativePath="..\ModificationManager\ModificationManager.h"
 				>
 			</File>
@@ -260,4 +222,38 @@
 			>
 		</Filter>
+		<Filter
+			Name="Quelldateien"
+			Filter="cpp;c;cc;cxx;def;odl;idl;hpj;bat;asm;asmx"
+			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}"
+			>
+			<File
+				RelativePath="..\ellipsoidTechnique.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\ModificationVisitor.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\myTerrainTechnique.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\rampedEllipsoidTechnique.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\ReaderWriterTerrainMod.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\region.cpp"
+				>
+			</File>
+			<File
+				RelativePath="..\terrainModificationTechnique.cpp"
+				>
+			</File>
+		</Filter>
 	</Files>
 	<Globals>