Index: /osgVisual/trunk/include/sky_Silverlining/skySilverLining_ProjectionMatrixCallback.h
===================================================================
--- /osgVisual/trunk/include/sky_Silverlining/skySilverLining_ProjectionMatrixCallback.h	(revision 291)
+++ /osgVisual/trunk/include/sky_Silverlining/skySilverLining_ProjectionMatrixCallback.h	(revision 292)
@@ -67,12 +67,22 @@
 		keys->push_back(osgAnimation::Vec2Keyframe(      0.0, osg::Vec2(     1.0,     80000.0)));
 		keys->push_back(osgAnimation::Vec2Keyframe(     50.0, osg::Vec2(     5.0,     90000.0)));
-	//keys->push_back(osgAnimation::Vec2Keyframe(    500.0, osg::Vec2(     5.0,    100000.0)));
-	//keys->push_back(osgAnimation::Vec2Keyframe(   1000.0, osg::Vec2(    10.0,    100000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe(    500.0, osg::Vec2(     5.0,    100000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe(   1000.0, osg::Vec2(    10.0,    100000.0)));
 	//keys->push_back(osgAnimation::Vec2Keyframe(  10000.0, osg::Vec2(   100.0,   1000000.0)));
 	//keys->push_back(osgAnimation::Vec2Keyframe(1000000.0, osg::Vec2(100000.0, 200000000.0)));
-		keys->push_back(osgAnimation::Vec2Keyframe(    500.0, osg::Vec2(     5.0,    100000.0)));
-		keys->push_back(osgAnimation::Vec2Keyframe(   1000.0, osg::Vec2(    10.0,    100000.0)));
-		keys->push_back(osgAnimation::Vec2Keyframe(  10000.0, osg::Vec2(   50.0,   1000000.0)));
-		keys->push_back(osgAnimation::Vec2Keyframe(1000000.0, osg::Vec2(100.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe(   10000.0, osg::Vec2(   50.0,   1000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 1000000.0, osg::Vec2(  100.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 2000000.0, osg::Vec2(  250.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 3000000.0, osg::Vec2(  500.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 4000000.0, osg::Vec2( 1000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 5000000.0, osg::Vec2(10000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 6000000.0, osg::Vec2(  10000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 7000000.0, osg::Vec2( 100000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 8000000.0, osg::Vec2(1000000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe( 9000000.0, osg::Vec2(1250000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe(10000000.0, osg::Vec2(2500000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe(11000000.0, osg::Vec2(5000000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe(12000000.0, osg::Vec2(7500000.0, 200000000.0)));
+		keys->push_back(osgAnimation::Vec2Keyframe(50000000.0, osg::Vec2(15000000.0,2000000000.0)));
 
     }
Index: /osgVisual/trunk/src/sky_Silverlining/skySilverLining_skyDrawable.cpp
===================================================================
--- /osgVisual/trunk/src/sky_Silverlining/skySilverLining_skyDrawable.cpp	(revision 291)
+++ /osgVisual/trunk/src/sky_Silverlining/skySilverLining_skyDrawable.cpp	(revision 292)
@@ -70,9 +70,10 @@
 
         direction = osg::Vec3(x, y, z);
-        ambient = osg::Vec4(ra, ga, ba, 1.0);
+		ambient = osg::Vec4(ra, ga, ba, 1.0);
+        //ambient = osg::Vec4(ra*0.1, ga*0.1, ba*0.1, 1.0);	// For use with shadow
         diffuse = osg::Vec4(rd, gd, bd, 1.0);
 
         // xform the light direction into camera coordinates
-        osg::Quat view = _view->getCamera()->getViewMatrix().getRotate();
+        //osg::Quat view = _view->getCamera()->getViewMatrix().getRotate();
         //direction = view * direction;
         direction.normalize();
@@ -80,5 +81,6 @@
         light->setAmbient(ambient);
         light->setDiffuse(diffuse);
-        light->setSpecular(osg::Vec4(0,0,0,1));
+        //light->setSpecular(osg::Vec4(0,0,0,1));
+		light->setSpecular(osg::Vec4(1.0,1.0,1.0,1));	// Test
         light->setPosition(osg::Vec4(direction.x(), direction.y(), direction.z(), 0));
     }