Index: /experimental/distortionNG/extViewer.cpp
===================================================================
--- /experimental/distortionNG/extViewer.cpp	(revision 314)
+++ /experimental/distortionNG/extViewer.cpp	(revision 315)
@@ -16,5 +16,5 @@
 extViewer::extViewer(osg::ArgumentParser& arguments) : Viewer(arguments)
 {
-//	setUpViewForManualDistortion(0);
+
 }
 
@@ -29,5 +29,5 @@
 }
 
-void extViewer::setUpViewForManualDistortion(osg::Image* intensityMap, unsigned int screenNum)
+void extViewer::setUpViewForManualDistortion(unsigned int screenNum, osg::Image* intensityMap, const osg::Matrixd& projectorMatrix)
 {
 	OSG_INFO<<"View::setUpViewForManualDistortion(sn="<<screenNum<<", im="<<intensityMap<<")"<<std::endl;
@@ -99,5 +99,5 @@
     {
         osg::ref_ptr<osg::Camera> camera = new osg::Camera;
-        camera->setName("Scene camera");
+        camera->setName("Scene cam");
         camera->setGraphicsContext(gc.get());
         camera->setViewport(new osg::Viewport(0,0,camera_width, camera_height));
@@ -117,6 +117,6 @@
     {
         osg::Geode* geode = new osg::Geode();
-        //geode->addDrawable(createParoramicSphericalDisplayDistortionMesh(osg::Vec3(0.0f,0.0f,0.0f), osg::Vec3(width,0.0f,0.0f), osg::Vec3(0.0f,height,0.0f), radius, collar, applyIntensityMapAsColours ? intensityMap : 0, projectorMatrix));
-		geode->addDrawable(createMesh(16, 19));
+		//geode->addDrawable(createParoramicSphericalDisplayDistortionMesh(osg::Vec3(0.0f,0.0f,0.0f), osg::Vec3(width,0.0f,0.0f), osg::Vec3(0.0f,height,0.0f), 1, 0.45, 0, projectorMatrix));
+		geode->addDrawable(createMesh(160, 190));
 
         // new we need to add the texture to the mesh, we do so by creating a
@@ -225,19 +225,19 @@
 
 
-	osg::ComputeBoundsVisitor cbv;
-	cbv.applyDrawable(geom);
-	osg::BoundingBox box = cbv.getBoundingBox();
-	if (!box.valid()) 
-		std::cout << "Invalid bounding box!"; 
-	geom->setInitialBound(box);
-
-	osg::ref_ptr<osg::Texture2D> texture = new osg::Texture2D;
+	//osg::ComputeBoundsVisitor cbv;
+	//cbv.applyDrawable(geom);
+	//osg::BoundingBox box = cbv.getBoundingBox();
+	//if (!box.valid()) 
+	//	std::cout << "Invalid bounding box!"; 
+	//geom->setInitialBound(box);
+
+	/*osg::ref_ptr<osg::Texture2D> texture = new osg::Texture2D;
 	texture->setImage( osgDB::readImageFile("Images/osg256.png") );
 	texture->setFilter( osg::Texture2D::MIN_FILTER, osg::Texture2D::LINEAR_MIPMAP_LINEAR );
 	texture->setFilter( osg::Texture2D::MAG_FILTER, osg::Texture2D::LINEAR_MIPMAP_LINEAR );
-	geom->getOrCreateStateSet()->setTextureAttributeAndModes( 0, texture.get() );
+	geom->getOrCreateStateSet()->setTextureAttributeAndModes( 0, texture.get() );*/
 
 	// Create normals
-	osgUtil::SmoothingVisitor::smooth( *geom );
+	//osgUtil::SmoothingVisitor::smooth( *geom );
 
 	return geom.release();
Index: /experimental/distortionNG/extViewer.h
===================================================================
--- /experimental/distortionNG/extViewer.h	(revision 314)
+++ /experimental/distortionNG/extViewer.h	(revision 315)
@@ -14,5 +14,5 @@
 
 		/** Convenience method for projection on curved screens using a slave camera rendering scene and a second camera doing distortion correction to present on a nonplaner display.*/
-        void setUpViewForManualDistortion(osg::Image* intensityMap, unsigned int screenNum=0);
+        void setUpViewForManualDistortion(unsigned int screenNum=0, osg::Image* intensityMap=0, const osg::Matrixd& projectorMatrix = osg::Matrixd());
 
 		static osg::Geometry* createMesh(unsigned int column, unsigned int row);
Index: /experimental/distortionNG/main.cpp
===================================================================
--- /experimental/distortionNG/main.cpp	(revision 314)
+++ /experimental/distortionNG/main.cpp	(revision 315)
@@ -41,4 +41,6 @@
     // construct the viewer.
     extViewer viewer(arguments);
+	viewer.setUpViewForManualDistortion();
+
 
     // set up the camera manipulators.
@@ -104,23 +106,25 @@
 			return 1;
 		}
+		else
+			viewer.setSceneData( rootnode );
     }
 
-	osg::ref_ptr<osg::Geode> geode = new osg::Geode;
-	geode->addDrawable( extViewer::createMesh(16, 9) );
-	geode->getOrCreateStateSet()->setMode( GL_LIGHTING, osg::StateAttribute::OFF );
-	geode->getOrCreateStateSet()->setAttributeAndModes( new osg::PolygonOffset(1.0f, 1.0f) );
+	//osg::ref_ptr<osg::Geode> geode = new osg::Geode;
+	//geode->addDrawable( extViewer::createMesh(16, 9) );
+	//geode->getOrCreateStateSet()->setMode( GL_LIGHTING, osg::StateAttribute::OFF );
+	//geode->getOrCreateStateSet()->setAttributeAndModes( new osg::PolygonOffset(1.0f, 1.0f) );
 
-	osg::ref_ptr<distortionHandler> selector = new distortionHandler( viewer.getCamera() );
+	//osg::ref_ptr<distortionHandler> selector = new distortionHandler( viewer.getCamera() );
 
-	osg::ref_ptr<osg::Group> root = new osg::Group;
-	root->addChild( geode.get() );
-	root->addChild( selector->createVertexHighlighter() );
+	//osg::ref_ptr<osg::Group> root = new osg::Group;
+	//root->addChild( geode.get() );
+	//root->addChild( selector->createVertexHighlighter() );
 
-	viewer.addEventHandler( selector.get() );
-	viewer.setSceneData( root.get() );
+	//viewer.addEventHandler( selector.get() );
+	//viewer.setSceneData( root.get() );
 
-	// Avoid that the highlighter is culled away
-	osg::CullSettings::CullingMode mode = viewer.getCamera()->getCullingMode();
-	viewer.getCamera()->setCullingMode( mode & (~osg::CullSettings::SMALL_FEATURE_CULLING) );
+	//// Avoid that the highlighter is culled away
+	//osg::CullSettings::CullingMode mode = viewer.getCamera()->getCullingMode();
+	//viewer.getCamera()->setCullingMode( mode & (~osg::CullSettings::SMALL_FEATURE_CULLING) );
 	
 	// run the viewers main loop